src/WSN.Admin/Models/ErrorViewModel.cs
using System;

namespace WSN.Admin.Models
{
    public class ErrorViewModel
    {
        public string RequestId { get; set; }

        public bool ShowRequestId => !string.IsNullOrEmpty(RequestId);
    }
}

src/WSN.Admin/Controllers/CellsController.cs
using System.Net;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Authorization;
using Microsoft.AspNetCore.Mvc;
using WSN.Admin.RequestModels;
using WSN.Admin.Services.Interfaces;
using ASPInfrastructure.Filters;
using Infrastructure.Domain.Singletons;

namespace WSN.Admin.Controllers
{
    [Authorize(Roles = RolesSingleton.Admin)]
    public class CellsController : Controller
    {

        private readonly ICellService _cellService;

        public CellsController(ICellService cellService)
        {
            _cellService = cellService;
        }

        public async Task<IActionResult> Index() => View(await _cellService.GetTableAsync());

        public IActionResult New() => View(new AddCellRequestModel());

        [HttpPost, ModelStateMustBeValid(nameof(New))]
        public async Task<IActionResult> Add(AddCellRequestModel request)
        {
            if(await _cellService.AddAsync(request) == null)
                return FailedToSaveCell(nameof(New), request);

            HttpContext.Response.StatusCode = (int)HttpStatusCode.Created;
            return View(nameof(Index), await _cellService.GetTableAsync());
        }

        [CellMustExist("_404"), Route("[controller]/[action]/{cellId:int}")]
        public async Task<IActionResult> Edit(int cellId) => View(await _cellService.GetAsync(cellId));

        [HttpPost, CellMustExist("_404", Order = 1), ModelStateMustBeValid(nameof(Edit), Order = 2)]
        public async Task<IActionResult> SaveEdit(EditCellRequestModel request)
        {
            if (await _cellService.UpdateAsync(request) == null)
                return FailedToSaveCell(nameof(Edit), request);

            return RedirectToAction(nameof(Index));

        }

        [CellMustExist("_404"), Route("[controller]/[action]/{cellId:int}")]
        public async Task<IActionResult> See(int cellId) => View(await _cellService.GetSeeAsync(cellId));

        [CellMustExist("_404"), Route("[controller]/[action]/{cellId:int}")]
        public async Task<IActionResult> Delete(int cellId)
        {
            if (await _cellService.DeleteAsync(cellId) == null)
                return FailedToSaveCell("DeleteFailed");

            return RedirectToAction(nameof(Index));
        }

        private IActionResult FailedToSaveCell(string viewName, object model = null)
        {
            HttpContext.Response.StatusCode = (int)HttpStatusCode.InternalServerError;
            ModelState.AddModelError(string.Empty, "Failed while saving cell.");
            if(model != null)
                return View(viewName, model);

            return View(viewName);
        }
    } 
}

src/WSN.Admin/Controllers/HomeController.cs
using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Mvc;
using Microsoft.Extensions.Logging;
using WSN.Admin.Models;

namespace WSN.Admin.Controllers
{
    public class HomeController : Controller
    {
        private readonly ILogger<HomeController> _logger;

        public HomeController(ILogger<HomeController> logger)
        {
            _logger = logger;
        }

        public IActionResult Index()
        {
            return View();
        }

        public IActionResult Privacy()
        {
            return View();
        }

        [ResponseCache(Duration = 0, Location = ResponseCacheLocation.None, NoStore = true)]
        public IActionResult Error()
        {
            return View(new ErrorViewModel { RequestId = Activity.Current?.Id ?? HttpContext.TraceIdentifier });
        }
    }
}

src/WSN.Admin/Controllers/LoginController.cs
using System.Net;
using System.Threading.Tasks;
using ASPInfrastructure.Filters;
using Infrastructure.Domain.Singletons;
using Microsoft.AspNetCore.Authorization;
using Microsoft.AspNetCore.Mvc;
using WSN.Admin.Extensions;
using WSN.Admin.RequestModels;
using WSN.Admin.Services.Interfaces;

namespace WSN.Admin.Controllers
{
    public class LoginController : Controller
    {
        private readonly IUserService _userService;

        public LoginController(IUserService userService)
        {
            _userService = userService;
        }

        [AllowAnonymous]
        public IActionResult Login() => View(new LoginRequestModel());

        [Authorize(Roles = RolesSingleton.Admin)]
        public async Task<IActionResult> Logout()
        {
            await _userService.LogoutAsync();
            return RedirectToAction(nameof(Login));
        }

        [AllowAnonymous]
        public IActionResult Denied() => View();

        [HttpPost, ModelStateMustBeValid(nameof(Login))]
        public async Task<IActionResult> Authenticate(LoginRequestModel request)
        {
            if(await _userService.AuthenticateAsync(request))
            {
                return this.RedirectToForeignAction<PanelController>(nameof(PanelController.Index));
            }

            HttpContext.Response.StatusCode = (int)HttpStatusCode.NotFound;

            ModelState.AddModelError(string.Empty, "User not found");
            return View(nameof(Login));
        }
    }
}

src/WSN.Admin/Controllers/PanelController.cs
using Infrastructure.Domain.Singletons;
using Microsoft.AspNetCore.Authorization;
using Microsoft.AspNetCore.Mvc;

namespace WSN.Admin.Controllers
{
    [Authorize(Roles = RolesSingleton.Admin)]
    public class PanelController : Controller
    {
        public IActionResult Index()
        {
            return View();
        }
    }
}

src/WSN.Admin/Controllers/SchedulesController.cs
using System;
using System.Net;
using System.Threading.Tasks;
using Infrastructure.Domain.Singletons;
using Microsoft.AspNetCore.Authorization;
using Microsoft.AspNetCore.Mvc;
using WSN.Admin.RequestModels;
using WSN.Admin.Services.Interfaces;

namespace WSN.Admin.Controllers
{
    [Authorize(Roles = RolesSingleton.Admin)]
    public class SchedulesController : Controller
    {
        private readonly IMonitoringScheduleService _service;

        public SchedulesController(IMonitoringScheduleService service)
        {
            _service = service;
        }

        public async Task<IActionResult> Index() => View(await _service.GetAsync());

        public async Task<IActionResult> New()
        {
            var request = new AddScheduleRequestModel
            {
                DateTime = DateTime.UtcNow
            };

            if (await _service.AddAsync(request) == null)
            {
                HttpContext.Response.StatusCode = (int)HttpStatusCode.InternalServerError;
                ModelState.AddModelError(null, "Unable to create schedule");
            }
            else
            {
                HttpContext.Response.StatusCode = (int)HttpStatusCode.Created;
            }

            return View(nameof(Index), await _service.GetAsync());
        }
    }
}

src/WSN.Admin/Views/Cells/DeleteFailed.cshtml
<div class="alert alert-danger">
    Falha ao deletar célula!
</div>

src/WSN.Admin/Views/Cells/Edit.cshtml
@model EditCellRequestModel
@{await Html.RenderPartialAsync("~/Views/Shared/Components/ReturnToMenuComponent.cshtml"); }

<form asp-action="SaveEdit" asp-route-id="@Model.CellId" method="post" enctype="multipart/form-data">
    <div asp-validation-summary="All" class="text-danger"></div>

    <input type="hidden" asp-for="CellId" />

    <div class="form-group row">
        <div class="col-sm-4">
            <label>Name</label>
            <input type="text" class="form-control" asp-for="Name">
            <span asp-validation-for="Name" />
        </div>

        <div class="col-sm-4">
            <label>Latitude</label>
            <input type="text" class="form-control" asp-for="Latitude" />
            <span asp-validation-for="Latitude" />
        </div>

        <div class="col-sm-4">
            <label>Longitude</label>
            <input type="text" class="form-control" asp-for="Longitude" />
            <span asp-validation-for="Longitude" />
        </div>
    </div>

    <div class="form-group row">
        <div class="col">
            <label>Address</label>
            <input type="text" class="form-control" asp-for="Address" />
            <span asp-validation-for="Address" />
        </div>
    </div>

    <button type="submit" class="btn btn-primary">Salvar</button>

</form>

src/WSN.Admin/Views/Cells/Index.cshtml
@model IEnumerable<CellTableResponseModel>
@{await Html.RenderPartialAsync("~/Views/Shared/Components/ReturnToMenuComponent.cshtml");}

<h1 class="display-4">Células</h1>

@if (Model.Count() == 0)
{
    <p class="lead">Nenhuma Célula Cadastrada!</p>
}
else
{
    <table class="table border-bottom">
        <thead>
            <tr>
                <th scope="col">Nome</th>
                <th scope="col">Endereço</th>
                <th scope="col">Status</th>
                <th scope="col">Ações</th>
            </tr>
        </thead>
        <tbody>
            @foreach (var item in Model)
            {
                <tr>
                    <td>@item.Name</td>
                    <td>@item.Address</td>
                    @if (item.Deleted)
                    {
                        <td>
                            <span class="badge badge-danger">Deletado</span>
                        </td>
                    }
                    else
                    {
                        <td>
                            <span class="badge badge-success">Ativo</span>
                        </td>
                    }

                <td>
                    <a asp-action="See" asp-route-id="@item.Id" class="text-decoration-none text-dark">
                        <svg width="1em" height="1em" viewBox="0 0 16 16" class="bi bi-eye-fill" fill="currentColor" xmlns="http://www.w3.org/2000/svg">
                            <path d="M10.5 8a2.5 2.5 0 1 1-5 0 2.5 2.5 0 0 1 5 0z" />
                            <path fill-rule="evenodd" d="M0 8s3-5.5 8-5.5S16 8 16 8s-3 5.5-8 5.5S0 8 0 8zm8 3.5a3.5 3.5 0 1 0 0-7 3.5 3.5 0 0 0 0 7z" />
                        </svg>
                    </a>

                    <a asp-action="Delete" asp-route-id="@item.Id" class="text-decoration-none text-dark">
                        <svg width="1em" height="1em" viewBox="0 0 16 16" class="bi bi-x-circle-fill" fill="currentColor" xmlns="http://www.w3.org/2000/svg">
                            <path fill-rule="evenodd" d="M16 8A8 8 0 1 1 0 8a8 8 0 0 1 16 0zM5.354 4.646a.5.5 0 1 0-.708.708L7.293 8l-2.647 2.646a.5.5 0 0 0 .708.708L8 8.707l2.646 2.647a.5.5 0 0 0 .708-.708L8.707 8l2.647-2.646a.5.5 0 0 0-.708-.708L8 7.293 5.354 4.646z" />
                        </svg>
                    </a>

                    <a asp-action="Edit" asp-route-id="@item.Id" class="text-decoration-none text-dark">
                        <svg width="1em" height="1em" viewBox="0 0 16 16" class="bi bi-pencil-fill" fill="currentColor" xmlns="http://www.w3.org/2000/svg">
                            <path fill-rule="evenodd" d="M12.854.146a.5.5 0 0 0-.707 0L10.5 1.793 14.207 5.5l1.647-1.646a.5.5 0 0 0 0-.708l-3-3zm.646 6.061L9.793 2.5 3.293 9H3.5a.5.5 0 0 1 .5.5v.5h.5a.5.5 0 0 1 .5.5v.5h.5a.5.5 0 0 1 .5.5v.5h.5a.5.5 0 0 1 .5.5v.207l6.5-6.5zm-7.468 7.468A.5.5 0 0 1 6 13.5V13h-.5a.5.5 0 0 1-.5-.5V12h-.5a.5.5 0 0 1-.5-.5V11h-.5a.5.5 0 0 1-.5-.5V10h-.5a.499.499 0 0 1-.175-.032l-.179.178a.5.5 0 0 0-.11.168l-2 5a.5.5 0 0 0 .65.65l5-2a.5.5 0 0 0 .168-.11l.178-.178z" />
                        </svg>
                    </a>
                </td>
                </tr>
            }
        </tbody>
    </table>
}

<a class="btn btn-success" asp-action="New" asp-controller="Cells">

    <svg width="1em" height="1em" viewBox="0 0 16 16" class="bi bi-cloud-plus" fill="currentColor" xmlns="http://www.w3.org/2000/svg">
        <path fill-rule="evenodd" d="M4.406 3.342A5.53 5.53 0 0 1 8 2c2.69 0 4.923 2 5.166 4.579C14.758 6.804 16 8.137 16 9.773 16 11.569 14.502 13 12.687 13H3.781C1.708 13 0 11.366 0 9.318c0-1.763 1.266-3.223 2.942-3.593.143-.863.698-1.723 1.464-2.383zm.653.757c-.757.653-1.153 1.44-1.153 2.056v.448l-.445.049C2.064 6.805 1 7.952 1 9.318 1 10.785 2.23 12 3.781 12h8.906C13.98 12 15 10.988 15 9.773c0-1.216-1.02-2.228-2.313-2.228h-.5v-.5C12.188 4.825 10.328 3 8 3a4.53 4.53 0 0 0-2.941 1.1z" />
        <path fill-rule="evenodd" d="M8 5.5a.5.5 0 0 1 .5.5v1.5H10a.5.5 0 0 1 0 1H8.5V10a.5.5 0 0 1-1 0V8.5H6a.5.5 0 0 1 0-1h1.5V6a.5.5 0 0 1 .5-.5z" />
    </svg>

    Nova Célula
</a>

src/WSN.Admin/Views/Cells/New.cshtml
@model AddCellRequestModel
@{await Html.RenderPartialAsync("~/Views/Shared/Components/ReturnToMenuComponent.cshtml"); }

<form asp-action="Add" method="post" enctype="multipart/form-data">
    <div asp-validation-summary="All" class="text-danger"></div>

    <div class="form-group row">
        <div class="col-sm-4">
            <label>Name</label>
            <input type="text" class="form-control" asp-for="Name">
            <span asp-validation-for="Name" />
        </div>

        <div class="col-sm-4">
            <label>Latitude</label>
            <input type="text" class="form-control" asp-for="Latitude" />
            <span asp-validation-for="Latitude" />
        </div>

        <div class="col-sm-4">
            <label>Longitude</label>
            <input type="text" class="form-control" asp-for="Longitude" />
            <span asp-validation-for="Longitude" />
        </div>
    </div>

    <div class="form-group row">
        <div class="col">
            <label>Address</label>
            <input type="text" class="form-control" asp-for="Address"/>
            <span asp-validation-for="Address" />
        </div>
    </div>

    <button type="submit" class="btn btn-primary">Cadastrar</button>
</form>

src/WSN.Admin/Views/Cells/See.cshtml
@model SeeCellResponseModel
@{await Html.RenderPartialAsync("~/Views/Shared/Components/ReturnToMenuComponent.cshtml"); }

<form>
    <div class="form-group row">
        <div class="col-sm-4">
            <label>Name</label>
            <input type="text" class="form-control" asp-for="Name" readonly>
        </div>

        <div class="col-sm-4">
            <label>Latitude</label>
            <input type="text" class="form-control" asp-for="Latitude" readonly/>
        </div>

        <div class="col-sm-4">
            <label>Longitude</label>
            <input type="text" class="form-control" asp-for="Longitude" readonly/>
        </div>
    </div>

    <div class="form-group row">
        <div class="col">
            <label>Address</label>
            <input type="text" class="form-control" asp-for="Address" readonly/>
        </div>
    </div>
</form>

src/WSN.Admin/Views/Home/Index.cshtml
@{
    ViewData["Title"] = "Home Page";
}

<div class="text-center">
    <h1 class="display-4">Welcome</h1>
    <p>Learn about <a href="https://docs.microsoft.com/aspnet/core">building Web apps with ASP.NET Core</a>.</p>
</div>

src/WSN.Admin/Views/Login/Denied.cshtml
<div class="alert alert-danger">
    Acesso negado! Você não tem permissão para acessar essa página.
</div>

@await Html.PartialAsync("Login", new LoginRequestModel())  

src/WSN.Admin/Views/Login/Login.cshtml
@model LoginRequestModel

<form asp-action="Authenticate" method="post" enctype="multipart/form-data" asp-antiforgery="true">
    <div class="text-danger" asp-validation-summary="All"></div>

    <div class="form-group">
        <label>Usuário</label>
        <input type="text" class="form-control" asp-for="User">
        <span asp-validation-for="User" class="text-danger"></span>
    </div>

    <div class="form-group">
        <label>Senha</label>
        <input type="password" class="form-control" asp-for="Password">
        <span asp-validation-for="Password" class="text-danger"></span>
    </div>
    <button type="submit" class="btn btn-primary">Sign In</button>
</form>

src/WSN.Admin/Views/Panel/Index.cshtml
<div class="alert alert-info mb-3 row">
    Painel administrativo - <a asp-controller="Login" asp-action="Logout">Sair</a>
</div>

@{
    var responseModel = new MenuResponseModel
    {
        MenuSection = "Menu Principal",
        Titles = new List<string>()
{
            "Gerenciar Células",
            "Gerenciar Monitoramentos"
        },
        Colors = new List<string>()
{
            "primary",
            "success"
        },
        Descriptions = new List<string>()
{
            "Gerenciar células registradas na base de dados",
            "Ver os monitoramentos já feitos ou agendar um para agora"
        },
        Controllers = new List<string>()
{
            "Cells",
            "Schedules"
        },
        Actions = new List<string>()
{
            "Index",
            "Index"
        }
    };

    await Html.RenderPartialAsync("~/Views/Shared/Components/MenuSectionComponent.cshtml", responseModel);
}

@section Css {
    <link href="~/css/painel.css" type="text/css" rel="stylesheet" />
}

src/WSN.Admin/Views/Schedules/Index.cshtml
@{await Html.RenderPartialAsync("~/Views/Shared/Components/ReturnToMenuComponent.cshtml");}
@model IEnumerable<ScheduleResponseModel>

@if (Model.Count() == 0)
{
    <p class="lead">Nada Encontrado</p>
}
else
{
    <table class="table border-bottom mb-2">
        <thead>
            <tr>
                <th scope="col">Momento da Medição</th>
            </tr>
        </thead>
        <tbody>
            @foreach (var item in Model)
            {
                <tr>
                    <td>@item.CreatedAt</td>
                </tr>
            }
        </tbody>
    </table>
}

<a class="btn btn-success" asp-action="New">

    <svg width="1em" height="1em" viewBox="0 0 16 16" class="bi bi-calendar-date-fill" fill="currentColor" xmlns="http://www.w3.org/2000/svg">
        <path fill-rule="evenodd" d="M4 .5a.5.5 0 0 0-1 0V1H2a2 2 0 0 0-2 2v1h16V3a2 2 0 0 0-2-2h-1V.5a.5.5 0 0 0-1 0V1H4V.5zM16 14V5H0v9a2 2 0 0 0 2 2h12a2 2 0 0 0 2-2zm-6.664-1.21c-1.11 0-1.656-.767-1.703-1.407h.683c.043.37.387.82 1.051.82.844 0 1.301-.848 1.305-2.164h-.027c-.153.414-.637.79-1.383.79-.852 0-1.676-.61-1.676-1.77 0-1.137.871-1.809 1.797-1.809 1.172 0 1.953.734 1.953 2.668 0 1.805-.742 2.871-2 2.871zm.066-2.544c.625 0 1.184-.484 1.184-1.18 0-.832-.527-1.23-1.16-1.23-.586 0-1.168.387-1.168 1.21 0 .817.543 1.2 1.144 1.2zm-2.957-2.89v5.332H5.77v-4.61h-.012c-.29.156-.883.52-1.258.777V8.16a12.6 12.6 0 0 1 1.313-.805h.632z" />
    </svg>

    Agendar Para Agora
</a>

src/WSN.Admin/Views/Shared/Components/MenuSectionComponent.cshtml
@model MenuResponseModel


<div class="row border rounded mb-3">
    <h1 class="display-4 w-100 bg-dark text-light pl-1 font-weight-bold rounded-top fonte-menu mb-0">@Model.MenuSection</h1>

    @for (int i = 0; i < Model.Titles.Count(); i++)
    {
        <div class="media border-bottom w-100 mt-2">
            <a class="quadrado bg-@Model.Colors.ElementAt(i) rounded mr-2 ml-1 mt-2" asp-controller="@Model.Controllers.ElementAt(i)" asp-action="@Model.Actions.ElementAt(i)"></a>
            <p class="media-body">
                <a class="d-block text-body font-weight-bold" asp-controller="@Model.Controllers.ElementAt(i)" asp-action="@Model.Actions.ElementAt(i)"> @Model.Titles.ElementAt(i)</a>
                <a class="text-muted" asp-controller="@Model.Controllers.ElementAt(i)" asp-action="@Model.Actions.ElementAt(i)">
                    @Model.Descriptions.ElementAt(i)
                </a>
            </p>
        </div>
    }
</div>

src/WSN.Admin/Views/Shared/Components/ReturnToMenuComponent.cshtml
<a class="btn btn-info mb-3" asp-controller="Panel" asp-action="Index">Retornar ao Painel</a>

src/WSN.Admin/Views/Shared/_404.cshtml
<div class="alert alert-danger">
    Erro 404 - O conteúdo procurado não foi encontrado!
</div>

src/WSN.Admin/Views/Shared/_Layout.cshtml
<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>@ViewData["Title"] - WSN.Admin</title>
    <link rel="stylesheet" href="~/lib/bootstrap/dist/css/bootstrap.min.css" />
    <link rel="stylesheet" href="~/css/site.css" />
    @RenderSection("Css", required: false)
</head>
<body>
    <header>
        <nav class="navbar navbar-expand-sm navbar-toggleable-sm navbar-light bg-white border-bottom box-shadow mb-3">
            <div class="container">
                <a class="navbar-brand" asp-area="" asp-controller="Home" asp-action="Index">WSN.Admin</a>
                <button class="navbar-toggler" type="button" data-toggle="collapse" data-target=".navbar-collapse" aria-controls="navbarSupportedContent"
                        aria-expanded="false" aria-label="Toggle navigation">
                    <span class="navbar-toggler-icon"></span>
                </button>
                <div class="navbar-collapse collapse d-sm-inline-flex flex-sm-row-reverse">
                    <ul class="navbar-nav flex-grow-1">
                        <li class="nav-item">
                            <a class="nav-link text-dark" asp-area="" asp-controller="Home" asp-action="Index">Home</a>
                        </li>

                        @if (Context.User.Identity.IsAuthenticated)
                        {
                            <li class="nav-item">
                                <a class="nav-link text-dark" asp-area="" asp-controller="Panel" asp-action="Index">Painel</a>
                            </li>
                        }
                        else
                        {
                            <li class="nav-item">
                                <a class="nav-link text-dark" asp-area="" asp-controller="Login" asp-action="Login">Entrar</a>
                            </li>
                        }
                    </ul>
                </div>
            </div>
        </nav>
    </header>
    <div class="container">
        <main role="main" class="pb-3">
            @RenderBody()
        </main>
    </div>

    <footer class="border-top footer text-muted">
        <div class="container">
            &copy; 2020 - WSN.Admin - <a asp-area="" asp-controller="Home" asp-action="Privacy">Privacy</a>
        </div>
    </footer>
    <script src="~/lib/jquery/dist/jquery.min.js"></script>
    <script src="~/lib/bootstrap/dist/js/bootstrap.bundle.min.js"></script>
    <script src="~/js/site.js" asp-append-version="true"></script>
    @RenderSection("Scripts", required: false)
</body>
</html>